Code

variable $projectdesc needs to be set before checking against unchanged default.
[git.git] / git-applymbox.sh
1 #!/bin/sh
2 ##
3 ## "dotest" is my stupid name for my patch-application script, which
4 ## I never got around to renaming after I tested it. We're now on the
5 ## second generation of scripts, still called "dotest".
6 ##
7 ## Update: Ryan Anderson finally shamed me into naming this "applymbox".
8 ##
9 ## You give it a mbox-format collection of emails, and it will try to
10 ## apply them to the kernel using "applypatch"
11 ##
12 ## The patch application may fail in the middle.  In which case:
13 ## (1) look at .dotest/patch and fix it up to apply
14 ## (2) re-run applymbox with -c .dotest/msg-number for the current one.
15 ## Pay a special attention to the commit log message if you do this and
16 ## use a Signoff_file, because applypatch wants to append the sign-off
17 ## message to msg-clean every time it is run.
18 ##
19 ## git-am is supposed to be the newer and better tool for this job.
21 USAGE='[-u] [-k] [-q] [-m] (-c .dotest/<num> | mbox) [signoff]'
22 . git-sh-setup
24 git var GIT_COMMITTER_IDENT >/dev/null || exit
26 keep_subject= query_apply= continue= utf8=-u resume=t
27 while case "$#" in 0) break ;; esac
28 do
29         case "$1" in
30         -u)     utf8=-u ;;
31         -n)     utf8=-n ;;
32         -k)     keep_subject=-k ;;
33         -q)     query_apply=t ;;
34         -c)     continue="$2"; resume=f; shift ;;
35         -m)     fall_back_3way=t ;;
36         -*)     usage ;;
37         *)      break ;;
38         esac
39         shift
40 done
42 case "$continue" in
43 '')
44         rm -rf .dotest
45         mkdir .dotest
46         num_msgs=$(git-mailsplit "$1" .dotest) || exit 1
47         echo "$num_msgs patch(es) to process."
48         shift
49 esac
51 files=$(git-diff-index --cached --name-only HEAD) || exit
52 if [ "$files" ]; then
53    echo "Dirty index: cannot apply patches (dirty: $files)" >&2
54    exit 1
55 fi
57 case "$query_apply" in
58 t)      touch .dotest/.query_apply
59 esac
60 case "$fall_back_3way" in
61 t)      : >.dotest/.3way
62 esac
63 case "$keep_subject" in
64 -k)     : >.dotest/.keep_subject
65 esac
67 signoff="$1"
68 set x .dotest/0*
69 shift
70 while case "$#" in 0) break;; esac
71 do
72     i="$1" 
73     case "$resume,$continue" in
74     f,$i)       resume=t;;
75     f,*)        shift
76                 continue;;
77     *)
78             git-mailinfo $keep_subject $utf8 \
79                 .dotest/msg .dotest/patch <$i >.dotest/info || exit 1
80             test -s .dotest/patch || {
81                 echo "Patch is empty.  Was is split wrong?"
82                 exit 1
83             }
84             git-stripspace < .dotest/msg > .dotest/msg-clean
85             ;;
86     esac
87     while :; # for fixing up and retry
88     do
89         git-applypatch .dotest/msg-clean .dotest/patch .dotest/info "$signoff"
90         case "$?" in
91         0)
92                 # Remove the cleanly applied one to reduce clutter.
93                 rm -f .dotest/$i
94                 ;;
95         2)
96                 # 2 is a special exit code from applypatch to indicate that
97                 # the patch wasn't applied, but continue anyway 
98                 ;;
99         *)
100                 ret=$?
101                 if test -f .dotest/.query_apply
102                 then
103                         echo >&2 "* Patch failed."
104                         echo >&2 "* You could fix it up in your editor and"
105                         echo >&2 "  retry.  If you want to do so, say yes here"
106                         echo >&2 "  AFTER fixing .dotest/patch up."
107                         echo >&2 -n "Retry [y/N]? "
108                         read yesno
109                         case "$yesno" in
110                         [Yy]*)
111                                 continue ;;
112                         esac
113                 fi
114                 exit $ret
115         esac
116         break
117     done
118     shift
119 done
120 # return to pristine
121 rm -fr .dotest